/*****************************************************************************
 Copyright (c) 1993 UUNET Technologies
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement:
      This product includes software developed by UUNET Technologies
 4. The name UUNET Technologies may not be used to endorse or promote products  
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE UUNET Technologies ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 ARE DISCLAIMED.  IN NO EVENT SHALL THE UUNET Technologies BE LIABLE
 FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 SUCH DAMAGE.

*****************************************************************************/

/*
 * Adapted from the program written by:
 *
 *	Written by Jvrgen Hdgg 1993 <jh@efd.lth.se>
 *
 *	(This filter is written for use in a MTA written in perl.)
 *	
 *	Please send comments and bugfixes when you find them.
 *	Permission to use and change this program is given for any purpose
 *	as long as this note remains unchanged.
 *	
 *	The usage() is the manual.
 *	Use encdec as you wish :-)
 *
 * Hacked by jmalcolm@uunet.uu.net. Most mistakes are probably my fault.
 */

#include <sfio.h>
#include <string.h>
#include <ctype.h>

char	vec[] =
	"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	
void	encode_base64(Sfio_t *in, Sfio_t *out);
void	decode_base64(Sfio_t *in, Sfio_t *out);

#if 0
void	encode_quoted();
void	decode_quoted();
#endif

void	encode_base64(in, out)
Sfio_t *in, *out;
{
	int	c,
		n = 0,
		p,
		i,
		count = 0,
		val = 0;
	char	enc[4];

	while ((c = sfgetc(in)) != EOF)
	{
		if (n++ <= 2)
		{
			val <<= 8;
			val += c;
			continue;
		}

		for (i = 0; i < 4; i++)
		{
			enc[i] = val & 63;
			val >>= 6;
		}

		for (i = 3; i >= 0; i--)
			sfputc(out,vec[enc[i]]);
		n = 1;
		count += 4;
		val = c;

		if (count >= 760)
		{
			sfprintf(out,"\n");
			count = 0;
		}
	}
	if (n == 1)
	{
		val <<= 16;
		for (i = 0; i < 4; i++)
		{
			enc[i] = val & 63;
			val >>= 6;
		}
		enc[0] = enc[1] = 64;
	}
	if (n == 2)
	{
		val <<= 8;
		for (i = 0; i < 4; i++)
		{
			enc[i] = val & 63;
			val >>= 6;
		}
		enc[0] = 64;
	}
	if (n == 3)
		for (i = 0; i < 4; i++)
		{
			enc[i] = val & 63;
			val >>= 6;
		}
	if (n)
	{
		for (i = 3; i >= 0; i--)
			sfputc(out,vec[enc[i]]);
	}
/*	sfprintf(out,"\n");*/
}


void	decode_base64(in,out)
Sfio_t *in, *out;
{
	int	d, i, num, len, j, val;
	char	nw[4], *buf = 0, *p, *c;


	while (1)
	{ /* evil hack - why is this necessary? -jmalcolm */
	  buf =  sfgetr(in, '\n', 1);
	  if (!buf)
	    buf = sfgetr(in, '\n', -1);
	  if (!buf)
	    break;
		len = strlen(buf)-1;
		for (i = 0; i < len; i += 4)
		{
			val = 0;
			num = 3;
			c = buf+i; 
			if (c[2] == '=')
				num = 1;
			else if (c[3] == '=')
				num = 2;

			for (j = 0; j <= num; j++)
			{
				if (!(p = strchr(vec, c[j])))
				{
					sfprintf(sfstderr,
						 "encdec: %s not in base64\n",
						 buf);
					exit(1);
				}
				d = p-vec;
				d <<= (3-j)*6;
				val += d;
			}
			for (j = 2; j >= 0; j--)
			{
				nw[j] = val & 255;
				val >>= 8;
			}
			sfwrite(out,nw, num);
		}
	}
}

#define	MAX	512

#if 0
void	encode_quoted()
{
	int		count = 0;
	unsigned char	buf[MAX], *p;

	while (fgets(buf, MAX-2, stdin))
	{
		buf[strlen(buf)-1] = '\0';

		for (p = buf; *p; p++)
		{
			if (count > 73)
			{
				printf("=\n");
				count = 0;
			}
			if (*p == 10)
			{
				printf("\n");
				count = 0;
			}
			else if (*p == 9 || *p == 32)
			{
				if (!*(p+1))
				{
					printf("=%02X", *p);
					count += 3;
				}
				else
				{
					putchar(*p);
					count++;
				}
				continue;
			}
			else if ((*p >= 33 && *p <= 60) ||
				(*p >= 62 && *p <= 126))
			{
				putchar(*p);
				count++;
			}
			else
			{
				printf("=%02X", *p);
				count += 3;
			}
			
		}
		printf("\n");
		count = 0;
	}
}

int hex(int x)
{
	return (isdigit(x) ? (x-'0') : isxdigit(x) ? ((x & 0x5f) - 'A')+10 : 0);
}

void	decode_quoted()
{
	int		x1, x2,
			count = 0,
			soft_line_break = 0;
	unsigned char	buf[MAX], *p;

	while (fgets(buf, MAX-2, stdin))
	{
		buf[strlen(buf)-1] = '\0';

		soft_line_break = 0;
		for (p = buf; *p; p++)
		{
			if (*p == 10)
				putchar(*p);
			else if (*p == '=')
			{
				if (!*(p+1))
				{
					soft_line_break++;
					continue;
				}
				p++;
				x1 = hex(*p++);
				x2 = hex(*p);
				putchar(x1*16+x2);
			}
			else
				putchar(*p);
		}
		if (!soft_line_break)
			putchar('\n');
	}
}

#endif

